Subject: :protocol (was: draft-kinnear-httpbis-http2-transport questions)

From: Kari Hurtta <[email-masked]>
Date: Sat, 23 Mar 2019 09:56:30 +0200 (EET)

> If the point is to enable UDP, then there are a few features I might want to request. 

Hmm.

:protocol and SETTINGS_ENABLE_CONNECT_PROTOCOL  from RFC 8441 

does give that:

https://tools.ietf.org/html/rfc8441#section-4

|   o  On requests bearing the :protocol pseudo-header field, the
|      :authority pseudo-header field is interpreted according to
|      Section 8.1.2.3 of [RFC7540] instead of Section 8.3 of that
|      document.  In particular, the server MUST NOT create a tunnel to
|      the host indicated by the :authority as it would with a CONNECT
|      method request that was not modified by this extension.

https://tools.ietf.org/html/rfc7540#section-8.3

|   A proxy that supports CONNECT establishes a TCP connection [TCP] to
|   the server identified in the ":authority" pseudo-header field.  Once
|   this connection is successfully established, the proxy sends a
|   HEADERS frame containing a 2xx series status code to the client, as
|   defined in [RFC7231], Section 4.3.6.

So if you want open some IP connection to the server identified in the 
":authority" pseudo-header field and want it to be OTHER than
TCP then you can not use :protocol.

:protocol says that do not open tunnel oo host given on 
:authority.

If you want use other IP protocols than TCP
then you need invent another :keyword  from :method=CONNECT
( and own SETTINGS paramater )

( Other IP protocols include
  UDP
  DCCP
  SCTP
)

I suggest

  :transport

for that.

/ Kari Hurtta